
var c cR cH y_R y_H R R_ZLB pi_cpiR pi_cpiH lR lH wR wH cR_R cR_H cH_R cH_H
    pRstar pHstar zR1 zR2 zH1 zH2 Q S_R S_H pi_R pi_H pdisp_R pdisp_H
    b th lumpsum_tax tauL_R tauL_H transfer transfer_H transfer_R xi_pref
    profit_R profit_H ;

varexo transfer_shock lH_shock xi_shock yH_shock ;

parameters beta sigma thetaR thetaH epsilon varphi lambda gamma alpha_H alpha_R 
           chi chi_H zeta xi rho_LR psi_b psi_LR tf_Y TL_Y pi_ss pi_Rss pi_Hss
           wRss wHss LHss LRss Css CHss CRss CR_Rss CR_Hss CH_Rss CH_Hss
           Yss YRss YHss Rss Qss SHss SRss ZR1_ss ZR2_ss ZH1_ss ZH2_ss
           tauL_Rss tauL_Hss transfer_Hss transfer_Rss transfer_ss 
           lumpsum_tax_ss bss th_ss b_Y rho_xi alpha
           rhoR1 rhoR2 phi_pi phi_x phi_dy profit_Rss profit_Hss ;

load para_file ;
set_param_value('beta',beta);           % Discount factor
set_param_value('sigma',sigma);         % Inverse of EIS
set_param_value('thetaR',thetaR);         % ES across varieties
set_param_value('thetaH',thetaH);         % ES across varieties
set_param_value('epsilon',epsilon);     % ES between R and H-goods  
set_param_value('varphi',varphi);       % Inverse Frisch
set_param_value('lambda',lambda);       % Population of HTM HH
set_param_value('gamma',gamma);         % Price indexation
set_param_value('alpha',alpha);         % DRS parameter
set_param_value('alpha_H',alpha_H);     % weight on R-good: HTM HH
set_param_value('alpha_R',alpha_R);     % weight on R-good: Ricardian HH
set_param_value('zeta',zeta);           % Progessivity of Labor Tax (=0 : no tax for HTM)
set_param_value('xi',xi);               % Fraction of transfers going to HTM HH
set_param_value('rho_LR',rho_LR);       % Tax smoothing rule
set_param_value('psi_b',psi_b);         % Lump-sum tax response to debt
set_param_value('psi_LR',psi_LR);       % Labor tax rate response to debt
set_param_value('TL_Y',TL_Y);           % Labor tax revenue to GDP
set_param_value('tf_Y',tf_Y);           % Total transfers to GDP
set_param_value('b_Y',b_Y);             % Debt to GDP
set_param_value('pi_ss',pi_ss);         % SS inflation
set_param_value('pi_Rss',pi_Rss);       % SS inflation
set_param_value('pi_Hss',pi_Hss);       % SS inflation
set_param_value('Rss',Rss);             % SS nominal rate
set_param_value('rho_xi',rho_xi);   	% preference shock persistence
set_param_value('rhoR1',rhoR1);         % Taylor rule smoothing
set_param_value('rhoR2',rhoR2);         % Taylor rule smoothing
set_param_value('phi_pi',phi_pi);       % Taylor rule Inflation response
set_param_value('phi_x',phi_x);         % Taylor rule output gap response
set_param_value('phi_dy',phi_dy);       % Taylor rule output growth response



load ss_initial ;
set_param_value('LRss',LRss);          
set_param_value('LHss',LHss);         
set_param_value('SHss',SHss);        
set_param_value('SRss',SRss);     
set_param_value('Qss',Qss);        
set_param_value('Yss',Yss);       
set_param_value('tauL_Rss',tauL_Rss);
set_param_value('tauL_Hss',tauL_Hss);
set_param_value('transfer_Hss',transfer_Hss); 
set_param_value('transfer_Rss',transfer_Rss); 
set_param_value('transfer_ss',transfer_ss); 
set_param_value('lumpsum_tax_ss',lumpsum_tax_ss); 
set_param_value('bss',bss); 
set_param_value('th_ss',th_ss); 
set_param_value('CHss',CHss);     
set_param_value('CRss',CRss);     
set_param_value('chi',chi);     
set_param_value('chi_H',chi_H);     
set_param_value('YRss',YRss);   
set_param_value('YHss',YHss);     
set_param_value('CR_Rss',CR_Rss);
set_param_value('CR_Hss',CR_Hss);
set_param_value('CH_Hss',CH_Hss);
set_param_value('CH_Rss',CH_Rss);
set_param_value('wRss',wRss);
set_param_value('wHss',wHss);
set_param_value('ZR1_ss',ZR1_ss);
set_param_value('ZR2_ss',ZR2_ss);
set_param_value('ZH1_ss',ZH1_ss);
set_param_value('ZH2_ss',ZH2_ss);
set_param_value('Css',Css);
set_param_value('profit_Rss',profit_Rss);
set_param_value('profit_Hss',profit_Hss);

load('shock_file.mat');

model;
%(1) Ricardian HH Intertemporal EE
cR^(-sigma)*xi_pref = beta*R/pi_cpiR(+1)*cR(+1)^(-sigma)*xi_pref(+1) ;

%(2) Ricardian HH Intratemporal EE
chi*lR^varphi*cR^sigma = (1-tauL_R)*wR ;

%(3) Ricardian HH: PC 1
pRstar^(1-thetaR+thetaR/alpha) = thetaR/(thetaR-1)/alpha*zR1/zR2 ;

%(4) Ricardian HH: PC 2
zR1 = wR*y_R^(1/alpha) ;


%(5) Ricardian HH: PC 3
zR2 = S_R*y_R  ;


%(6) HTM HH budget constraint
cH = (1-tauL_H)*wH*lH + transfer_H/Q ;

%(6) HTM HH budget constraint
(1+lH_shock)^(1+varphi)*chi_H*lH^varphi*cH^sigma = (1-tauL_H)*wH ;
%chi_H*lH^(1+varphi)*cH^sigma = cH - transfer_H/Q ;

%(7) HTM HH: PC 1
pHstar^(1-thetaH+thetaH/alpha) = thetaH/(thetaH-1)/alpha*zH1/zH2 ;

%(8) HTM HH: PC 2
zH1 = Q*wH*y_H^(1/alpha) ;


%(9) HTM HH: PC 3
zH2 = Q*S_H*y_H ;


%(10) Output R-sector
y_R = (1-lambda)*cR_R + lambda*cH_R ;

%(11) Output H-sector
y_H = (1-lambda)*cR_H + lambda*cH_H ;

%(12) Consumption Ricardian HH 1
cR_R = alpha_R*S_R^(-epsilon)*cR ;

%(13) Consumption Ricardian HH 2
cR_H = exp((epsilon-1)*yH_shock)*(1-alpha_R)*(S_H*Q)^(-epsilon)*cR ;

%(14) Consumption HTM HH 2
cH_H = exp((epsilon-1)*yH_shock)*alpha_H*S_H^(-epsilon)*cH ;

%(15) Consumption HTM HH 2
cH_R = (1-alpha_H)*(S_R/Q)^(-epsilon)*cH ;

%(16) Aggregate consumption
%c = (1-lambda)*cR + lambda*Q*cH ;

%(17) Resource constraint
c = S_R*y_R + Q*S_H*y_H;

%(18) Aggregate output R good
(1-lambda)*lR = y_R^(1/alpha)*pdisp_R ;

%(19) Price dispersion R good
pdisp_R = 1 ;


%(20) Aggregate output H good
lambda*lH = y_H^(1/alpha)*pdisp_H ;

%(21) Price dispersion H good
pdisp_H = 1 ;


%(22) Aggregate price index 1
pRstar = 1 ;


%(23) Aggregate price index 2
pHstar = 1 ;


%(24) GBC
b + th = R(-1)*b(-1)/pi_cpiR - lumpsum_tax + transfer ;

%(25) Labor tax revenue
th = lambda*tauL_H*Q*wH*lH + (1-lambda)*tauL_R*wR*lR ;

%(26) Transfer
transfer = transfer_ss*(1+transfer_shock) ;

%(27) MP rule
R_ZLB/Rss = (R_ZLB(-1)/Rss)^rhoR1*(R_ZLB(-2)/Rss)^rhoR2*((((1-lambda)*pi_cpiR + lambda*pi_cpiH)/pi_ss)^phi_pi*(c/Css)^phi_x*(c/c(-1))^phi_dy)^(1-rhoR1-rhoR2) ;

%(27-1) MP with ZLB
R = R_ZLB ;

%(27-2) Inflation
%pi = (1-lambda)*pi_cpiR + lambda*pi_cpiH ;

%(28) Relative price relationship
1 = (alpha_R - (1-alpha_R)/alpha_H*(1-alpha_H))*S_R^(1-epsilon) + (1-alpha_R)/alpha_H*Q^(1-epsilon) ;

%(32) R-good Inflation
(S_H*Q)^(1-epsilon) = exp((1-epsilon)*yH_shock)*(1-alpha_R*S_R^(1-epsilon))/(1-alpha_R) ;

%(29) R-good Inflation
pi_cpiR^(1-epsilon) = (pi_R*pi_H)^(1-epsilon)/(alpha_R*(S_R*pi_H)^(1-epsilon) + (1-alpha_R*S_R^(1-epsilon))*pi_R^(1-epsilon)) ;

%(29) R-good Inflation
pi_H = S_H/S_H(-1)*pi_cpiH ;

%(13) Inflation relationship
pi_cpiH^(1-epsilon) = (pi_R*pi_H)^(1-epsilon)/(alpha_H*(S_H*pi_R)^(1-epsilon) + (1-alpha_H*S_H^(1-epsilon))*pi_H^(1-epsilon)) ;

%(33) Lump-sum tax rule
lumpsum_tax - lumpsum_tax_ss = psi_b*(b(-1) - bss) ;

%(34) labor tax rule (Ricardian)
tauL_R - tauL_Rss = rho_LR*(tauL_R(-1) - tauL_Rss) + (1-rho_LR)*psi_LR*(b(-1) - bss) ;

%(35) labor tax rule (HTM)
tauL_H = tauL_Hss ;

%(36) Transfer sharing rule (Ricardian)
(1-lambda)*transfer_R = (1-xi)*transfer ;

%(37) Transfer sharing rule (HTM)
lambda*transfer_H = xi*transfer ;

%(38) Labor supply shock
%lH = LHss*(1+lH_shock) ;

%(38) Preference shock
xi_pref = xi_pref(-1)^rho_xi*exp(xi_shock) ;

%(40) R-Profits
profit_R = S_R*y_R - (1-lambda)*wR*lR;

%(41) H-Profits
profit_H = Q*S_H*y_H - lambda*Q*wH*lH;

end;


initval;
c       = Css   ;
cR      = CRss  ;
cH      = CHss  ;
cR_R    = CR_Rss;
cR_H    = CR_Hss;
cH_R    = CH_Rss;
cH_H    = CH_Hss;
y_R     = YRss  ;
y_H     = YHss  ;
R_ZLB   = Rss   ;
R       = Rss   ;
pi_cpiR = pi_Rss ;
pi_cpiH = pi_Rss ;
pi_R    = pi_Rss ;
pi_H    = pi_Hss ;
lR      = LRss ;
lH      = LHss ;
wR      = wRss ;
wH      = wHss ;
pRstar  = 1 ;
pHstar  = 1 ;
zR1     = ZR1_ss;
zR2     = ZR2_ss;
zH1     = ZH1_ss;
zH2     = ZH2_ss;
Q       = Qss ;
S_R     = SRss;
S_H     = SHss;
pdisp_R = 1;
pdisp_H = 1;
b       = bss ;
th      = th_ss ;
tauL_R  = tauL_Rss ; 
tauL_H  = tauL_Hss ;
transfer= transfer_ss ;
xi_pref = 1 ;
lumpsum_tax= lumpsum_tax_ss ;
transfer_H = transfer_Hss ;
transfer_R = transfer_Rss ;
profit_R = profit_Rss ;
profit_H = profit_Hss ;
end;

steady;
check;

shocks;
var lH_shock; periods 1:3; values (lH_shock_values);
var yH_shock; periods 1:3; values (yH_shock_values) ;
var xi_shock; periods 1:3; values (xi_shock_values) ;
var transfer_shock; periods 1:12; values (transfer_values) ;
end;

perfect_foresight_setup(periods=1000) ;

%warning('off','MATLAB:nearlySingularMatrix')
warning('off','all')

perfect_foresight_solver(stack_solve_algo=6,noprint,maxit=15) ;

%stoch_simul(order=1) ;
%simul(periods=3000,stack_solve_algo=6,noprint,maxit=15) ;


