
var R pi s b tau realR beta_s g ;

varexo s_shock beta_shock g_shock;

parameters beta varphi lambda phi psi pi_ss Rss 
           CRss chi bss sss gss tauss psi_g ;

load para_file_simple_model ;
set_param_value('beta',beta);           % Discount factor
set_param_value('varphi',varphi);       % Inverse Frisch
set_param_value('lambda',lambda);       % Population of HTM HH
set_param_value('phi',phi);             % Taylor rule Inflation response
set_param_value('psi',psi);             % Lump-sum tax response to debt
set_param_value('psi_g',psi_g);             % Lump-sum tax response to debt
set_param_value('pi_ss',pi_ss);         % SS inflation
set_param_value('Rss',Rss);             % SS nominal rate

load ss_initial_simple_model ;
set_param_value('CRss',CRss);        
set_param_value('chi',chi);        
set_param_value('bss',bss);       
set_param_value('gss',gss);       
set_param_value('sss',sss);
set_param_value('tauss',tauss); 

load('shock_file.mat');

model;
%(2) Ricardian HH Intratemporal EE
chi*(CRss*beta_s(+1)/(beta*beta_s*realR) + 1/(1-lambda)*(s+g))^varphi*CRss*beta_s(+1)/(beta*beta_s*realR) = 1;

%(7) HTM HH: PC 3
b + tau = R(-1)/pi*b(-1) + s + g ;

%(8) Taylor rule
R/Rss = (pi/pi_ss)^phi ;

%(9) Tax rule
tau - tauss = psi*(b(-1) - bss) ;

%(9) Tax rule
g - gss = psi_g*(b(-1) - bss) + gss*g_shock;

%(10) Labor supply shock
s = sss*(1+s_shock) ;

%(11) real rate
realR = R/pi(+1); 

beta_s = (1+beta_shock) ;
end;

initval;
R   = Rss   ;
pi  = pi_ss ;
s   = sss;
b   = bss ;
g   = gss ;
tau = tauss ;
realR = Rss/pi_ss ;
beta_s = 1 ;
end;

steady;
check;

shocks;
var s_shock   ; periods 1:3; values (s_shock_values) ;
var beta_shock; periods 1:3; values (beta_shock_values) ;
var g_shock   ; periods 1:3; values (g_shock_values) ;
end;

perfect_foresight_setup(periods=500) ;

%warning('off','MATLAB:nearlySingularMatrix')
%warning('off','all')

perfect_foresight_solver(stack_solve_algo=6,noprint,maxit=15) ;
%perfect_foresight_solver(stack_solve_algo=7,solve_algo=4,noprint,maxit=15) ;
%perfect_foresight_solver(stack_solve_algo=0,noprint,maxit=15) ;


