
LRss = 0.301  ;
LHss = 0.251  ;

fun_SRss= @(x) ((1-alpha_H*x^(1-epsilon))/(alpha_R + (1-alpha_H-alpha_R)*x^(1-epsilon)))^(1/(1-epsilon)) ;
fun_Qss = @(x) ((1-alpha_R*fun_SRss(x)^(1-epsilon))/((1-alpha_R)*x^(1-epsilon)))^(1/(1-epsilon)) ;
fun_tauL_R = @(x) TL_Y*(fun_Qss(x)*x*(lambda*LHss)^alpha + fun_SRss(x)*((1-lambda)*LRss)^alpha)/...
                  (zeta*alpha*(thetaH-1)/thetaH*fun_Qss(x)*x*(lambda*LHss)^alpha + alpha*(thetaR-1)/thetaR*fun_SRss(x)*((1-lambda)*LRss)^alpha) ;
fun_Yss = @(x) fun_SRss(x)*((1-lambda)*LRss)^alpha + fun_Qss(x)*x*(lambda*LHss)^alpha ;

fun_CHss= @(x) (1-zeta*fun_tauL_R(x))*(thetaH-1)/thetaH*x*LHss^alpha*alpha*lambda^(alpha-1) + 1/fun_Qss(x)*xi/lambda*tf_Y*fun_Yss(x) ;
fun_QGss= @(x) (alpha_G*fun_SRss(x)^(1-epsilon)+(1-alpha_G)*(x*fun_Qss(x))^(1-epsilon))^(1/(1-epsilon)) ;
fun_CRss= @(x) (((1-lambda)*LRss)^alpha*fun_SRss(x)^(epsilon) -  ...
                lambda*(1-alpha_H)*(fun_Qss(x))^(epsilon)*fun_CHss(x) - ...
                alpha_G*(fun_QGss(x))^epsilon*g_Y*fun_Yss(x))/...
               ((1-lambda)*alpha_R) ;
fun_SHss= @(x) (lambda*LHss)^alpha*x^epsilon - (1-lambda)*(1-alpha_R)*fun_Qss(x)^(-epsilon)*fun_CRss(x) ...
               - (1-alpha_G)*(fun_Qss(x)/fun_QGss(x))^(-epsilon)*g_Y*fun_Yss(x) ...
               - lambda*alpha_H*fun_CHss(x) ;

SHss    = csolve2(fun_SHss,1,[],1e-10,500) ;
SRss    = fun_SRss(SHss) ;
Qss     = fun_Qss(SHss) ;
QGss    = fun_QGss(SHss) ;

tauL_Rss= fun_tauL_R(SHss) ;
tauL_Hss= zeta*tauL_Rss     ;
Yss     = fun_Yss(SHss) ;
CHss    = fun_CHss(SHss) ;
CRss    = fun_CRss(SHss) ;

transfer_Hss  = xi/lambda*tf_Y*Yss ;
transfer_Rss  = (1-xi)/(1-lambda)*tf_Y*Yss ;

YRss= ((1-lambda)*LRss)^alpha ;
YHss= ((lambda)*LHss)^alpha ;
CR_Rss = alpha_R*SRss^(-epsilon)*CRss ;
CR_Hss = (1-alpha_R)*(SHss*Qss)^(-epsilon)*CRss ;
CH_Hss = alpha_H*SHss^(-epsilon)*CHss ;
CH_Rss = (1-alpha_H)*(SRss/Qss)^(-epsilon)*CHss ;

wRss  = alpha*(thetaR-1)/thetaR*SRss*YRss^(1-1/alpha) ;
wHss  = alpha*(thetaH-1)/thetaH*SHss*YHss^(1-1/alpha) ;

chi  = (1-tauL_Rss)*wRss/(LRss^varphi*CRss^sigma) ;
chi_H= (1-tauL_Hss)*wHss/(LHss^varphi*CHss^sigma) ;

ZR1_ss = 1/(1-omegaR*beta)*wRss*YRss^(1/alpha) ;
ZR2_ss = 1/(1-omegaR*beta)*SRss*YRss ;
ZH1_ss = 1/(1-omegaH*beta)*Qss*wHss*YHss^(1/alpha) ;
ZH2_ss = 1/(1-omegaH*beta)*Qss*SHss*YHss ;

Css = (1-lambda)*CRss + lambda*Qss*CHss ;
CR2 = (alpha_R^(1/epsilon)*CR_Rss^((epsilon-1)/epsilon) + (1-alpha_R)^(1/epsilon)*CR_Hss^((epsilon-1)/epsilon))^(epsilon/(epsilon-1)) ;
CH2 = (alpha_H^(1/epsilon)*CH_Hss^((epsilon-1)/epsilon) + (1-alpha_H)^(1/epsilon)*CH_Rss^((epsilon-1)/epsilon))^(epsilon/(epsilon-1)) ;

bss = b_Y*Yss ;
transfer_ss = tf_Y*Yss ;
th_ss = TL_Y*Yss ;
Gss = g_Y*Yss ;
lumpsum_tax_ss = transfer_ss - (1-1/beta)*bss - th_ss + QGss*Gss ;

Yss2 = Css + QGss*Gss;
GRss  = alpha_G*(SRss/QGss)^(-epsilon)*Gss ;
GHss  = (1-alpha_G)*(Qss*SHss/QGss)^(-epsilon)*Gss ;

profit_Rss = SRss*YRss - (1-lambda)*wRss*LRss ;
profit_Hss = Qss*SHss*YHss - lambda*Qss*wHss*LHss;

if abs(CRss-CR2) + abs(CHss-CH2) + abs(Yss-Yss2)>1e-8
    msg = 'Error occurred.';
    error(msg)
end

save Dynare//ss_initial LRss LHss SHss SRss Qss Yss tauL_Rss tauL_Hss transfer_ss transfer_Hss ...
                CHss CRss chi chi_H YRss YHss CR_Rss CR_Hss CH_Hss CH_Rss wRss transfer_Rss ...
                wHss ZR1_ss ZR2_ss ZH1_ss ZH2_ss Css bss th_ss lumpsum_tax_ss profit_Rss profit_Hss ...
                Gss GRss GHss QGss ;
