function F = Model_System_T(x)

load para_file_csolve std_s std_b beta chi lambda varphi phi psi ...
                      Betapos RRpos Spos Bpos Taupos Rpos Pipos CRpos ...
                      CRss Rss tauss pi_ss bss sss xnum Numsim ...
                      s_shock_period b_shock_period x_steady rho_b;

s = size(x,1) ;
if s ~= Numsim*xnum, disp('Input vector should have same size of F'), return, end

F = zeros(size(x)) ;
        
for i = 1:Numsim
    s_shock = 0 ;
    b_shock = 0 ;
    if i <= s_shock_period 
        s_shock = std_s ;
    end
    if i <= b_shock_period 
        b_shock = std_b ;
    end
    i_cur = (i-1)*xnum ;
    i_lag = (i-2)*xnum ;
    i_lead = i*xnum ;
    
    if i == 1
        x_lag   =   kron(ones(1,size(x,2)),x_steady') ;
        x_lead  =   x(i_lead+1:i_lead+xnum,:)   ;
    elseif i == Numsim
        x_lag   =   x(i_lag+1:i_lag+xnum,:)   ;
        x_lead  =   kron(ones(1,size(x,2)),x_steady') ;
    else
        x_lag   =   x(i_lag+1:i_lag+xnum,:)   ;
        x_lead  =   x(i_lead+1:i_lead+xnum,:)   ;
    end
    x_cur = x(i_cur+1:i_cur+xnum,:)     ;
    
    F(i_cur+1:i_lead,:) = ...
           [x_lead(CRpos,:)./x_cur(CRpos,:) - beta*exp(-x_cur(Betapos,:)).*x_cur(RRpos,:) ; ...
            chi*(x_cur(CRpos,:) + 1/(1-lambda)*x_cur(Spos)).^varphi - 1./x_cur(CRpos,:) ; ...
            x_cur(Bpos,:) + x_cur(Taupos,:) - x_lag(Rpos,:)./x_cur(Pipos,:).*x_lag(Bpos,:) - x_cur(Spos,:)  ; ...
            x_cur(Rpos,:)/Rss - (x_cur(Pipos,:)/pi_ss).^phi ; ...
            x_cur(Taupos,:) - tauss - psi*(x_lag(Bpos,:) - bss) ; ...
            x_cur(Spos,:) - sss*(1+s_shock) ; ...
            x_cur(RRpos,:) - x_cur(Rpos,:)./x_lead(Pipos,:)   ; ...	
            x_cur(Betapos,:) - rho_b*x_lag(Betapos,:) - b_shock] ;

end


